#ifndef CFlatParoord_H
#define CFlatParoord_H

#include <xmdv/CFlatDisplay.h>
#include <xmdv/CParcoord.h>
#include <xmdv/Vec2.h>

class CFlatParcoord : public CFlatDisplay, public CParcoord
{
protected: 
    ARR<Vec2> poly;

// Set of local variables to maintain the current state of interaction
	int axis;
	double* mapedX;
	double* mapedYMean;
	double* mapedYMax;
	double* mapedYMin;

public:
	CFlatParcoord(CFlatDisplayInformation* hier_info);
    ~CFlatParcoord();

    //event handlers
    void InputMouseMotion(int x, int y);
    void InputButtonPress(int button, int x, int y);
    void InputButtonRelease(int button, int x, int y);
    void InputParcoordMouseMotion(grCanvas *canvas, int x,int y);

//protected:
	bool TestDimensionality();
    //draw single data
    void DrawSingleData(ARR<double> data, int datano = 0);
    void DrawSingleDataWithDimClusterExtends(ARR<double> mean, ARR<double> max, ARR<double> min, int datano);
    void DrawSingleDataWithTwoAxes(ARR<double> mean, ARR<double> max, ARR<double> min, int datano, bool unbrushed);
    //set parameters used for drawing, to be rewritten in subclasses;
    void SetParameters();
    void FreeSpace();
    //draw axes
    void DrawAxes();
    //set color and style for unbrushed data
    void SetUnbrushedColorAndStyle();
    //set color and style for average of brushes
    void SetAverageColorAndStyle();
    // Draw a single brush.
    void DrawSingleBrush(Brush *brush);
	void DrawParcoordBrushBoundRamp(grCanvas *canvas, Brush *brush, unsigned long color1, unsigned long color2);
	void DrawParcoordBrushBoundRampOutline(grCanvas *canvas, Brush *brush);
	void InputParcoordResizeBrush(grCanvas *canvas, int sx, int sy);
	void InputParcoordMoveBrush(grCanvas *canvas, int sx, int sy);
	void InputParcoordMultiSelect(grCanvas *canvas, int sx, int sy);
	void InputParcoordBoundRampResize(grCanvas *canvas, int sx, int sy);

};


#endif



